=== modified file 'NEWS'
--- NEWS	2010-03-24 07:13:35 +0000
+++ NEWS	2010-04-15 08:50:40 +0000
@@ -5,6 +5,36 @@
 .. contents:: List of Releases
    :depth: 1
 
+bzr 2.1.2
+#########
+
+:Codename: None
+:2.1.2: NOT RELEASED YET
+
+Compatibility Breaks
+********************
+
+New Features
+************
+
+Bug Fixes
+*********
+
+Improvements
+************
+
+Documentation
+*************
+
+API Changes
+***********
+
+Internals
+*********
+
+Testing
+*******
+
 
 bzr 2.1.1
 #########
@@ -387,12 +417,34 @@
   tests that 'failed' - they're all just failures.
   (Martin Pool)
 
+bzr 2.0.6
+#########
+
+:2.0.6: NOT RELEASED YET
+
+Bug Fixes
+*********
+
+* ``bzr revert`` now only takes write lock on working tree, instead of on 
+  both working tree and branch.
+  (Danny van Heumen, #498409)
+
+* ``bzr upgrade`` now creates the ``backup.bzr`` directory with the same
+  permissions as ``.bzr`` directory on a POSIX OS.
+  (Parth Malwankar, #262450)
+
+* Additional merges after an unrelated branch has been merged with its
+  history no longer crash when deleted files are involved.
+  (Vincent Ladeuil, John Arbash Meinel, #375898)
 
 bzr 2.0.5
 #########
 
-:Codename:
-:2.0.5: NOT RELEASED YET
+:2.0.5: 2010-03-23
+
+This fifth release in our 2.0 series addresses several user-inconvenience
+bugs.  None are critical, but upgrading is recommended for all users on
+earlier 2.0 releases.
 
 Bug Fixes
 *********
@@ -421,9 +473,6 @@
 * Handle renames correctly when there are files or directories that 
   differ only in case.  (Chris Jones, Martin Pool, #368931)
 
-* Fixed CHM generation by moving the NEWS section template into
-  a separate file. (Ian Clatworthy, #524184)
-
 * If ``bzr push --create-prefix`` triggers an unexpected ``NoSuchFile``
   error, report that error rather than failing with an unhelpful
   ``UnboundLocalError``.
@@ -443,6 +492,10 @@
 * Added ``location-alias`` help topic.
   (Andrew Bennetts, #337834)
 
+* Fixed CHM generation by moving the NEWS section template into
+  a separate file. (Ian Clatworthy, #524184)
+
+
 bzr 2.0.4
 #########
 

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2010-02-17 17:11:16 +0000
+++ bzrlib/builtins.py	2010-04-15 08:50:40 +0000
@@ -4145,7 +4145,7 @@
     def run(self, revision=None, no_backup=False, file_list=None,
             forget_merges=None):
         tree, file_list = tree_files(file_list)
-        tree.lock_write()
+        tree.lock_tree_write()
         self.add_cleanup(tree.unlock)
         if forget_merges:
             tree.set_parent_ids(tree.get_parent_ids()[:1])

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2010-02-17 17:11:16 +0000
+++ bzrlib/bzrdir.py	2010-04-15 08:50:40 +0000
@@ -580,8 +580,6 @@
             # already exists, but it should instead either remove it or make
             # a new backup directory.
             #
-            # FIXME: bug 262450 -- the backup directory should have the same
-            # permissions as the .bzr directory (probably a bug in copy_tree)
             old_path = self.root_transport.abspath('.bzr')
             new_path = self.root_transport.abspath('backup.bzr')
             ui.ui_factory.note('making backup of %s\n  to %s' % (old_path, new_path,))

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2010-02-17 17:11:16 +0000
+++ bzrlib/commands.py	2010-04-15 10:23:59 +0000
@@ -386,7 +386,7 @@
         # List of standard options directly supported
         self.supported_std_options = []
         self._operation = cleanup.OperationWithCleanups(self.run)
-    
+
     def add_cleanup(self, cleanup_func, *args, **kwargs):
         """Register a function to call after self.run returns or raises.
 
@@ -406,7 +406,7 @@
         resources (such as writing results to self.outf).
         """
         self._operation.cleanup_now()
-        
+
     @deprecated_method(deprecated_in((2, 1, 0)))
     def _maybe_expand_globs(self, file_list):
         """Glob expand file_list if the platform does not do that itself.

=== modified file 'bzrlib/lock.py'
--- bzrlib/lock.py	2009-10-07 08:17:25 +0000
+++ bzrlib/lock.py	2010-04-15 08:50:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -84,7 +84,7 @@
         return self.lock_url == other.lock_url and self.details == other.details
 
     def __repr__(self):
-        return '%s(%s%s)' % (self.__class__.__name__,
+        return '%s(%s, %s)' % (self.__class__.__name__,
                              self.lock_url, self.details)
 
 

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2010-02-17 23:40:51 +0000
+++ bzrlib/merge.py	2010-04-15 10:23:59 +0000
@@ -1051,21 +1051,38 @@
         other_root = self.tt.trans_id_file_id(other_root_file_id)
         if other_root == self.tt.root:
             return
+        if self.other_tree.inventory.root.file_id in self.this_tree.inventory:
+            # the other tree's root is a non-root in the current tree (as when
+            # a previously unrelated branch is merged into another)
+            return
         try:
             self.tt.final_kind(other_root)
+            other_root_is_present = True
         except errors.NoSuchFile:
-            return
-        if self.this_tree.has_id(self.other_tree.inventory.root.file_id):
-            # the other tree's root is a non-root in the current tree
-            return
-        self.reparent_children(self.other_tree.inventory.root, self.tt.root)
-        self.tt.cancel_creation(other_root)
-        self.tt.cancel_versioning(other_root)
-
-    def reparent_children(self, ie, target):
-        for thing, child in ie.children.iteritems():
+            # other_root doesn't have a physical representation. We still need
+            # to move any references to the actual root of the tree.
+            other_root_is_present = False
+        # 'other_tree.inventory.root' is not present in this tree. We are
+        # calling adjust_path for children which *want* to be present with a
+        # correct place to go.
+        for thing, child in self.other_tree.inventory.root.children.iteritems():
             trans_id = self.tt.trans_id_file_id(child.file_id)
-            self.tt.adjust_path(self.tt.final_name(trans_id), target, trans_id)
+            if not other_root_is_present:
+                # FIXME: Make final_kind returns None instead of raising
+                # NoSuchFile to avoid the ugly construct below -- vila 20100402
+                try:
+                    self.tt.final_kind(trans_id)
+                    # The item exist in the final tree and has a defined place
+                    # to go already.
+                    continue
+                except errors.NoSuchFile, e:
+                    pass
+            # Move the item into the root
+            self.tt.adjust_path(self.tt.final_name(trans_id),
+                                self.tt.root, trans_id)
+        if other_root_is_present:
+            self.tt.cancel_creation(other_root)
+            self.tt.cancel_versioning(other_root)
 
     def write_modified(self, results):
         modified_hashes = {}

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-02-16 16:08:40 +0000
+++ bzrlib/tests/__init__.py	2010-04-15 08:50:40 +0000
@@ -4376,3 +4376,27 @@
             return result
 except ImportError:
     pass
+
+class _PosixPermissionsFeature(Feature):
+
+    def _probe(self):
+        def has_perms():
+            # create temporary file and check if specified perms are maintained.
+            import tempfile
+
+            write_perms = stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR
+            f = tempfile.mkstemp(prefix='bzr_perms_chk_')
+            fd, name = f
+            os.close(fd)
+            os.chmod(name, write_perms)
+
+            read_perms = os.stat(name).st_mode & 0777
+            os.unlink(name)
+            return (write_perms == read_perms)
+
+        return (os.name == 'posix') and has_perms()
+
+    def feature_name(self):
+        return 'POSIX permissions support'
+
+posix_permissions_feature = _PosixPermissionsFeature()

=== modified file 'bzrlib/tests/blackbox/test_upgrade.py'
--- bzrlib/tests/blackbox/test_upgrade.py	2009-08-21 02:10:06 +0000
+++ bzrlib/tests/blackbox/test_upgrade.py	2010-04-15 08:50:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,6 +27,7 @@
     TestCaseInTempDir,
     TestCaseWithTransport,
     TestUIFactory,
+    posix_permissions_feature,
     )
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.transport import get_transport
@@ -154,6 +155,18 @@
         self.run_bzr('init-repository --format=metaweave repo')
         self.run_bzr('upgrade --format=knit repo')
 
+    def test_upgrade_permission_check(self):
+        """'backup.bzr' should retain permissions of .bzr. Bug #262450"""
+        self.requireFeature(posix_permissions_feature)
+        import os, stat
+        old_perms = stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR
+        backup_dir = 'backup.bzr'
+        self.run_bzr('init --format=1.6')
+        os.chmod('.bzr', old_perms)
+        self.run_bzr('upgrade')
+        new_perms = os.stat(backup_dir).st_mode & 0777
+        self.assertTrue(new_perms == old_perms)
+
 
 class SFTPTests(TestCaseWithSFTPServer):
     """Tests for upgrade over sftp."""

=== modified file 'bzrlib/tests/commands/__init__.py'
--- bzrlib/tests/commands/__init__.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/__init__.py	2010-04-15 08:50:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -41,6 +41,7 @@
         'bzrlib.tests.commands.test_pull',
         'bzrlib.tests.commands.test_push',
         'bzrlib.tests.commands.test_update',
+        'bzrlib.tests.commands.test_revert',
         ]
     # add the tests for the sub modules
     suite.addTests(loader.loadTestsFromModuleNames(testmod_names))

=== added file 'bzrlib/tests/commands/test_revert.py'
--- bzrlib/tests/commands/test_revert.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/commands/test_revert.py	2010-04-15 10:23:59 +0000
@@ -0,0 +1,67 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+import os
+from bzrlib import (
+    branch,
+    builtins,
+    errors,
+    lock,
+    )
+from bzrlib.tests import (
+    transport_util,
+    TestCaseInTempDir,
+    )
+
+
+class TestRevert(TestCaseInTempDir):
+
+    def setUp(self):
+        super(TestRevert, self).setUp()
+
+    def test_revert_tree_write_lock_and_branch_read_lock(self):
+
+        # install lock hooks to find out about cmd_revert's locking actions
+        locks_acquired = []
+        locks_released = []
+        lock.Lock.hooks.install_named_hook('lock_acquired',
+            locks_acquired.append, None)
+        lock.Lock.hooks.install_named_hook('lock_released',
+            locks_released.append, None)
+
+        # execute the revert command (There is nothing to actually revert,
+        # but locks are acquired either way.)
+        revert = builtins.cmd_revert()
+        revert.run()
+        # FIXME: the following is automated in trunk so the following line
+        # should not be present in trunk, the laternative is to call
+        # run_argv_aliases which will call run_direct which will call
+        # _operation.run_simple which will, finally, call the cleanups. Way too
+        # complicated for a temporary fix -- vila 20100415
+        revert.cleanup_now()
+
+        # make sure that only one lock is acquired and released.
+        self.assertLength(1, locks_acquired)
+        self.assertLength(1, locks_released)
+
+        # make sure that the nonces are the same, since otherwise
+        # this would not be the same lock.
+        self.assertEqual(locks_acquired[0].details, locks_released[0].details)
+
+        # make sure that the locks are checkout locks.
+        self.assertEndsWith(locks_acquired[0].lock_url, "/checkout/lock")
+        self.assertEndsWith(locks_released[0].lock_url, "/checkout/lock")
+

=== modified file 'bzrlib/tests/per_workingtree/test_merge_from_branch.py'
--- bzrlib/tests/per_workingtree/test_merge_from_branch.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_workingtree/test_merge_from_branch.py	2010-04-01 14:06:48 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -20,13 +20,14 @@
 import os
 
 from bzrlib import (
+    branchbuilder,
     errors,
     merge
     )
-from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
-
-
-class TestMergeFromBranch(TestCaseWithWorkingTree):
+from bzrlib.tests import per_workingtree
+
+
+class TestMergeFromBranch(per_workingtree.TestCaseWithWorkingTree):
 
     def create_two_trees_for_merging(self):
         """Create two trees that can be merged from.
@@ -114,3 +115,103 @@
                 self.tt.create_file('qux', trans_id)
         this.merge_from_branch(other.branch, merge_type=QuxMerge)
         self.assertEqual('qux', this.get_file_text('foo-id'))
+
+
+class TestMergedBranch(per_workingtree.TestCaseWithWorkingTree):
+
+    def make_branch_builder(self, relpath, format=None):
+        if format is None:
+            format = self.bzrdir_format
+        builder = branchbuilder.BranchBuilder(self.get_transport(),
+                                              format=format)
+        return builder
+
+    def make_inner_branch(self):
+        bld_inner = self.make_branch_builder('inner')
+        bld_inner.start_series()
+        bld_inner.build_snapshot(
+            '1', None,
+            [('add', ('', 'inner-root-id', 'directory', '')),
+             ('add', ('dir', 'dir-id', 'directory', '')),
+             ('add', ('dir/file1', 'file1-id', 'file', 'file1 content\n')),
+             ('add', ('file3', 'file3-id', 'file', 'file3 content\n')),
+             ])
+        bld_inner.build_snapshot(
+            '3', ['1'], [('modify', ('file3-id', 'new file3 contents\n')),])
+        bld_inner.build_snapshot(
+            '2', ['1'],
+            [('add', ('dir/file2', 'file2-id', 'file', 'file2 content\n')),
+             ])
+        bld_inner.finish_series()
+        br = bld_inner.get_branch()
+        return br
+
+    def assertTreeLayout(self, expected, tree):
+        tree.lock_read()
+        try:
+            actual = [e[0] for e in tree.list_files()]
+            # list_files doesn't guarantee order
+            actual = sorted(actual)
+            self.assertEqual(expected, actual)
+        finally:
+            tree.unlock()
+
+    def make_outer_tree(self):
+        outer = self.make_branch_and_tree('outer')
+        self.build_tree_contents([('outer/foo', 'foo')])
+        outer.add('foo', 'foo-id')
+        outer.commit('added foo')
+        inner = self.make_inner_branch()
+        outer.merge_from_branch(inner, to_revision='1', from_revision='null:')
+        outer.commit('merge inner branch')
+        outer.mkdir('dir-outer', 'dir-outer-id')
+        outer.move(['dir', 'file3'], to_dir='dir-outer')
+        outer.commit('rename imported dir and file3 to dir-outer')
+        return outer, inner
+
+    def test_file1_deleted_in_dir(self):
+        outer, inner = self.make_outer_tree()
+        outer.remove(['dir-outer/dir/file1'], keep_files=False)
+        outer.commit('delete file1')
+        outer.merge_from_branch(inner)
+        outer.commit('merge the rest')
+        self.assertTreeLayout(['dir-outer',
+                               'dir-outer/dir',
+                               'dir-outer/dir/file2',
+                               'dir-outer/file3',
+                               'foo'],
+                              outer)
+
+    def test_file3_deleted_in_root(self):
+        # Reproduce bug #375898
+        outer, inner = self.make_outer_tree()
+        outer.remove(['dir-outer/file3'], keep_files=False)
+        outer.commit('delete file3')
+        outer.merge_from_branch(inner)
+        outer.commit('merge the rest')
+        self.assertTreeLayout(['dir-outer',
+                               'dir-outer/dir',
+                               'dir-outer/dir/file1',
+                               'dir-outer/dir/file2',
+                               'foo'],
+                              outer)
+
+
+    def test_file3_in_root_conflicted(self):
+        outer, inner = self.make_outer_tree()
+        outer.remove(['dir-outer/file3'], keep_files=False)
+        outer.commit('delete file3')
+        nb_conflicts = outer.merge_from_branch(inner, to_revision='3')
+        self.assertEqual(4, nb_conflicts)
+        self.assertTreeLayout(['dir-outer',
+                               'dir-outer/dir',
+                               'dir-outer/dir/file1',
+                               # Ideally th conflict helpers should be in
+                               # dir-outer/dir but since we can't easily find
+                               # back the file3 -> outer-dir/dir rename, root
+                               # is good enough -- vila 20100401
+                               'file3.BASE',
+                               'file3.OTHER',
+                               'foo'],
+                              outer)
+

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2010-02-17 17:11:16 +0000
+++ bzrlib/transport/__init__.py	2010-04-15 08:50:40 +0000
@@ -1060,7 +1060,11 @@
         """
         source = self.clone(from_relpath)
         target = self.clone(to_relpath)
-        target.mkdir('.')
+
+        # create target directory with the same rwx bits as source.
+        # use mask to ensure that bits other than rwx are ignored.
+        stat = self.stat(from_relpath)
+        target.mkdir('.', stat.st_mode & 0777)
         source.copy_tree_to_transport(target)
 
     def copy_tree_to_transport(self, to_transport):

=== modified file 'doc/developers/testing.txt'
--- doc/developers/testing.txt	2009-12-23 05:04:12 +0000
+++ doc/developers/testing.txt	2010-04-15 08:50:40 +0000
@@ -317,6 +317,43 @@
 .. ~~~~~~~~~~~~
 
 
+Testing locking behaviour
+-------------------------
+
+In order to test the locking behaviour of commands, it is possible to install
+a hook that is called when a write lock is: acquired, released or broken.
+(Read locks also exist, they cannot be discovered in this way.)
+
+A hook can be installed by calling bzrlib.lock.Lock.hooks.install_named_hook.
+The three valid hooks are: `lock_acquired`, `lock_released` and `lock_broken`.
+
+Example::
+
+    locks_acquired = []
+    locks_released = []
+
+    lock.Lock.hooks.install_named_hook('lock_acquired',
+        locks_acquired.append, None)
+    lock.Lock.hooks.install_named_hook('lock_released',
+        locks_released.append, None)
+
+`locks_acquired` will now receive a LockResult instance for all locks acquired
+since the time the hook is installed.
+
+The last part of the `lock_url` allows you to identify the type of object that is locked.
+
+- BzrDir: `/branch-lock`
+- Working tree: `/checkout/lock`
+- Branch: `/branch/lock`
+- Repository: `/repository/lock`
+
+To test if a lock is a write lock on a working tree, one can do the following::
+
+    self.assertEndsWith(locks_acquired[0].lock_url, "/checkout/lock")
+
+See bzrlib/tests/commands/test_revert.py for an example of how to use this for
+testing locks.
+
 
 Skipping tests
 --------------
@@ -437,14 +474,20 @@
 
     self.requireFeature(StraceFeature)
 
-Features already defined in bzrlib.tests include:
+Available features
+~~~~~~~~~~~~~~~~~~
+
+Features already defined in bzrlib.tests or bzrlib.tests.features include:
 
  - SymlinkFeature,
  - HardlinkFeature,
  - OsFifoFeature,
  - UnicodeFilenameFeature,
- - FTPServerFeature, and
- - CaseInsensitiveFilesystemFeature.
+ - FTPServerFeature
+ - CaseInsensitiveFilesystemFeature
+ - posix_permissions_feature: the test can rely on unix-style 
+   permissions bits on files;
+   generally true on Unix but not on all filesystems
 
 
 Defining a new feature that tests can require

